#pragma pack(2)

#include <Pilot.h>
#include "ui-constants.h"
#include "skey.h"


/*
 *  Global data:
 *	Seq_{Fld|Str|Ptr}
 */

void Start_App( void );
void Stop_App( void );
void Event_Loop( void );


/*****************************************/

DWord PilotMain( Word cmd, Ptr cmd_PBP, Word launch_flags )
{
  switch( cmd )
  {
     case sysAppLaunchCmdNormalLaunch:
	Start_App();
	FrmGotoForm( Input_Form );
	Event_Loop();
	Stop_App();
	break;
     default:
	/* Something that we do not handle */
	break;
  }

  return 0;
}


/*****************************************/


void Start_App( void )
{
  /*
   *  We should load the prefs to fill in the default values
   * here.
   */

  return;
}


void Stop_App( void )
{
  /*
   *  Save the prefs
   */


  return;
}


/*****************************************/

/*
 *  Globals that we all need
 */
FormPtr		Current_Form;
FieldPtr	Seq_Ptr, Key_Ptr, PW_Ptr, Resp_Ptr;


/*****************************************/

void Event_Loop( void )
{
  EventType e;
  short err;

  while(1)
  {

    /*
     *  Poll for an event and distribute it to the appropriate
     * handler.
     */
    EvtGetEvent( &e, 200 );
    if( SysHandleEvent(&e) )
	continue;
    if( MenuHandleEvent( NULL, &e, &err ) )
	continue;

    switch( e.eType )
    {
      case appStopEvent:
	/*
	 *  Someone has requested that we close down and quit. 
	 *  No problem -- our prefs will be saved by the Stop_App() 
	 *  routine.
	 */
	return;


      case frmOpenEvent:
	/*
	 *  This should be the first event to occur when the app is
	 * opened.  The FrmGotoForm() function generates this event. 
	 * this would also be a good time to set the focus after 
	 * tracking down the pointers to the fields on our form. 
	 *  
	 * Assuming the Start_App() routine has initialized our default 
	 * prefs, we may also set the initial values here.
	 */
	Current_Form = FrmGetActiveForm();

	Seq_Ptr = FrmGetObjectPtr( Current_Form,
			FrmGetObjectIndex( Current_Form, Seq_Field ) );
	Key_Ptr = FrmGetObjectPtr( Current_Form,
			FrmGetObjectIndex( Current_Form, Key_Field ) );
	PW_Ptr = FrmGetObjectPtr( Current_Form,
			FrmGetObjectIndex( Current_Form, PW_Field ) );
	Resp_Ptr = FrmGetObjectPtr( Current_Form,
			FrmGetObjectIndex( Current_Form, Resp_Field ) );

	FrmDrawForm( Current_Form );
	FrmSetFocus( Current_Form,
			FrmGetObjectIndex( Current_Form, Seq_Field ) );

	/*
	 *  We should fill in values here
	 */
	break;


      case frmLoadEvent:
	/*
	 *  Also generated by FrmGotoForm()?  Weird.
	 * Code from plrctest.c
	 */
	Current_Form = FrmInitForm( e.data.frmLoad.formID );
	FrmSetActiveForm( Current_Form );
	break;

      case menuEvent:
	/*
	 *  We're not doing any menus, yet.
	 */
	break;

      case ctlSelectEvent:
	/*
	 *  Button presses, etc
	 */
	switch( e.data.ctlSelect.controlID )
	{
	  case Go_Button:
	    /*
	     *  We should do the actual work now.
	     */
	    skey_pilot();
	    break;
	  default:
	    /*
	     *  Some other button -- not ours?
	     */
	    break;
	}


      default:
	/*
	 *  Now that we're here, I don't know what else needs to be
	 * done.  Toss things up another level to the form handling
	 * code.
	 */
	FrmHandleEvent( Current_Form, &e );
	break;
    }

  }


  /*
   *  This should never be reached.
   */
  return;
}
