#pragma pack(2)

#include <Common.h>
#include <Pilot.h>
#include <System/Encrypt.h>
#include "skey.h"


/*****************************************/

/*
 *  We define our own, simple atoi() to avoid linking the entire
 * library.
 */
static int atoi( char *s )
{
  int i = 0;

  while( *s && '0' <= *s && *s <= '9' )
    i = 10*i + (int)(*s++) - '0';

  return i;
}


/*****************************************/


void skey_pilot( void )
{
  char *pw, *seq_str, *key;
  static char buf[128];
  unsigned long md_buf[4], digest[2];
  int seq, buflen;

  pw = FldGetTextPtr( PW_Ptr );
  seq_str = FldGetTextPtr( Seq_Ptr );
  key = FldGetTextPtr( Key_Ptr );

  seq = atoi( seq_str );

  /*
   *  Crunch the key and password together and then
   * run the result through md4.  We then fold the result into
   * 64 bits and pass it to etob()...
   */
  strcpy( buf, key );
  strcat( buf, pw );
  buflen = strlen( buf );
  
  EncDigestMD4( buf, buflen, (Byte*) md_buf );
  digest[0] = md_buf[0] ^ md_buf[2];
  digest[1] = md_buf[1] ^ md_buf[3];
  
  /*
   *  Now we iterate the number of times specified by the sequence
   * value.  This may be quite high, really, but that's ok...
   */
  while( seq-- != 0 )
  {
    EncDigestMD4( (BytePtr) digest, 2*sizeof(unsigned long), (Byte*) md_buf );
    digest[0] = md_buf[0] ^ md_buf[2];
    digest[1] = md_buf[1] ^ md_buf[3];
  }
  
  /*
   *  I/O...
   */
  btoe( buf, (char*) digest );
  FldSetTextPtr( Resp_Ptr, buf );
  FrmDrawForm( Current_Form );

  return;
}
